[versions]
apache  = "3.12.0"
arrow = "0.13.2"
assertj = "3.19.0"
azure-blob = "12.11.1"
azure-queue = "12.9.1"
coroutines = "1.5.0"
gradle-git-properties = "2.3.1"
jackson = "2.12.3"
junit = "5.7.1"
kotlin = "1.5.10"  #"1.5.20-M1"
mapstruct = "1.4.2.Final"
mongodb = "4.2.3"
sendgrid = "4.7.2"
springboot = "2.5.0"

[libraries]
# BOMs
arrow-stack = { module = "io.arrow-kt:arrow-stack", version.ref = "arrow" }
jackson-bom = { module = "com.fasterxml.jackson:jackson-bom", version.ref = "jackson" }
kotlin-bom = { module = "org.jetbrains.kotlin:kotlin-bom", version.ref = "kotlin" }

# Plugins
gradle-git-properties = { module = "gradle.plugin.com.gorylenko.gradle-git-properties:gradle-git-properties", version.ref = "gradle-git-properties" }
kotlin-allopen = { module = "org.jetbrains.kotlin:kotlin-allopen", version.ref = "kotlin" }
kotlin-jvm-gradle-plugin = { module = "org.jetbrains.kotlin:kotlin-gradle-plugin", version.ref = "kotlin" }
kotlin-kapt-gradle-plugin = { module = "org.jetbrains.kotlin.kapt:org.jetbrains.kotlin.kapt.gradle.plugin", version.ref = "kotlin" }
kotlin-noarg-gradle-plugin = { module = "org.jetbrains.kotlin:kotlin-noarg", version.ref = "kotlin" }

# Packages
arrow-core = { module = "io.arrow-kt:arrow-core", version.ref = "arrow" }
assertj-core = { module = "org.assertj:assertj-core", version.ref = "assertj" }
azure-storage-blob = { module = "com.azure:azure-storage-blob", version.ref = "azure-blob" }
azure-storage-queue = { module = "com.azure:azure-storage-queue", version.ref = "azure-queue" }
commons-lang3 = { module = "org.apache.commons:commons-lang3",  version.ref = "apache" }
jackson-datatype-jsr310 = { module = "com.fasterxml.jackson.datatype:jackson-datatype-jsr310", version.ref = "jackson" }
jackson-module-kotlin = { module = "com.fasterxml.jackson.datatype:jackson-module-kotlin", version.ref = "jackson" }
jackson-module-paranamer = { module = "com.fasterxml.jackson.datatype:jackson-module-paranamer", version.ref = "jackson" }
jackson-modules-java8 = { module = "com.fasterxml.jackson.datatype:jackson-modules-java8", version.ref = "jackson" }
junit-jupiter = { module = "org.junit.jupiter:junit-jupiter", version.ref = "junit" }
kotlin-reflect = { module = "org.jetbrains.kotlin:kotlin-reflect", version.ref = "kotlin" }
kotlin-stdlib = { module = "org.jetbrains.kotlin:kotlin-stdlib", version.ref = "kotlin" }
kotlin-test-junit5 = { module = "org.jetbrains.kotlin:kotlin-test-junit5", version.ref = "kotlin" }
kotlinx-coroutines-core = { module = "org.jetbrains.kotlinx:kotlinx-coroutines-core", version.ref = "coroutines" }
kotlinx-coroutines-reactive = { module = "org.jetbrains.kotlinx:kotlinx-coroutines-reactive", version.ref = "coroutines" }
kotlinx-coroutines-reactor = { module = "org.jetbrains.kotlinx:kotlinx-coroutines-reactor", version.ref = "coroutines" }
mapstruct-core = { module = "org.mapstruct:mapstruct", version.ref = "mapstruct" }
mapstruct-processor = { module = "org.mapstruct:mapstruct-processor", version.ref = "mapstruct" }
mongodb-driver-reactivestreams = { module = "org.mongodb:mongodb-driver-reactivestreams", version.ref = "mongodb" }
sendgrid-java = { module = "com.sendgrid:sendgrid-java", version.ref = "sendgrid" }
spring-boot-core = { module = "org.springframework.boot:spring-boot", version.ref = "springboot" }
spring-boot-starter-rsocket = { module = "org.springframework.boot:spring-boot-starter-rsocket", version.ref = "springboot" }

[bundles]
azure = ["azure-storage-blob", "azure-storage-queue"]
coroutines = ["kotlinx-coroutines-core", "kotlinx-coroutines-reactive", "kotlinx-coroutines-reactor"]
jackson = ["jackson-datatype-jsr310", "jackson-module-kotlin", "jackson-module-paranamer", "jackson-modules-java8"]
kotlin = ["kotlin-allopen", "kotlin-jvm-gradle-plugin", "kotlin-kapt-gradle-plugin", "kotlin-reflect", "kotlin-stdlib", "kotlin-test-junit5"]
mongodb = ["mongodb-driver-reactivestreams"]
rsocket = []
springboot = ["spring-boot-core"]
utilities = ["commons-lang3", "mapstruct-core", "mapstruct-processor"]
